use v6;
#  -- DO NOT EDIT --
# generated by: etc/generator.p6 

unit module LibXML::Native::Gen::valid;
# The DTD validation:
#    API for the DTD handling and the validity checking 
use LibXML::Native::Defs :LIB, :xmlCharP;

class xmlAttributeTable is repr('CPointer') {
    method Copy( --> xmlAttributeTable) is native(LIB) is symbol('xmlCopyAttributeTable') {*};
    method Free() is native(LIB) is symbol('xmlFreeAttributeTable') {*};
}

class xmlElementTable is repr('CPointer') {
    method Copy( --> xmlElementTable) is native(LIB) is symbol('xmlCopyElementTable') {*};
    method Free() is native(LIB) is symbol('xmlFreeElementTable') {*};
}

class xmlIDTable is repr('CPointer') {
    method Free() is native(LIB) is symbol('xmlFreeIDTable') {*};
}

class xmlNotationTable is repr('CPointer') {
    method Copy( --> xmlNotationTable) is native(LIB) is symbol('xmlCopyNotationTable') {*};
    method Free() is native(LIB) is symbol('xmlFreeNotationTable') {*};
}

class xmlRefTable is repr('CPointer') {
    method Free() is native(LIB) is symbol('xmlFreeRefTable') {*};
}

class xmlValidCtxt is repr('CStruct') {
    has Pointer $.userData; # user specific data block
    has xmlValidityErrorFunc $.error; # the callback in case of errors
    has xmlValidityWarningFunc $.warning; # the callback in case of warning Node analysis stack used when validating within entities
    has xmlNode $.node; # Current parsed Node
    has int32 $.nodeNr; # Depth of the parsing stack
    has int32 $.nodeMax; # Max depth of the parsing stack
    has xmlNodePtr * $.nodeTab; # array of nodes
    has uint32 $.finishDtd; # finished validating the Dtd ?
    has xmlDoc $.doc; # the document
    has int32 $.valid; # temporary validity check result state state used for non-determinist content validation
    has xmlValidState * $.vstate; # current state
    has int32 $.vstateNr; # Depth of the validation stack
    has int32 $.vstateMax; # Max depth of the validation stack
    has xmlValidState * $.vstateTab; # array of validation states
    has xmlAutomata $.am; # the automata
    has xmlAutomataState $.state; # used to build the automata
    has Pointer $.am;
    has Pointer $.state;

    sub xmlNewValidCtxt( --> xmlValidCtxt) is native(LIB) is export {*};

    method AddAttributeDecl(xmlDtd $dtd, xmlCharP $elem, xmlCharP $name, xmlCharP $ns, xmlAttributeType $type, xmlAttributeDefault $def, xmlCharP $defaultValue, xmlEnumeration $tree --> xmlAttribute) is native(LIB) is symbol('xmlAddAttributeDecl') {*};
    method AddElementDecl(xmlDtd $dtd, xmlCharP $name, xmlElementTypeVal $type, xmlElementContent $content --> xmlElement) is native(LIB) is symbol('xmlAddElementDecl') {*};
    method AddID(xmlDoc $doc, xmlCharP $value, xmlAttr $attr --> xmlID) is native(LIB) is symbol('xmlAddID') {*};
    method AddNotationDecl(xmlDtd $dtd, xmlCharP $name, xmlCharP $PublicID, xmlCharP $SystemID --> xmlNotation) is native(LIB) is symbol('xmlAddNotationDecl') {*};
    method AddRef(xmlDoc $doc, xmlCharP $value, xmlAttr $attr --> xmlRef) is native(LIB) is symbol('xmlAddRef') {*};
    method Free() is native(LIB) is symbol('xmlFreeValidCtxt') {*};
    method BuildContentModel(xmlElement $elem --> int32) is native(LIB) is symbol('xmlValidBuildContentModel') {*};
    method NormalizeAttributeValue(xmlDoc $doc, xmlNode $elem, xmlCharP $name, xmlCharP $value --> xmlCharP) is native(LIB) is symbol('xmlValidCtxtNormalizeAttributeValue') {*};
    method ValidateAttributeDecl(xmlDoc $doc, xmlAttribute $attr --> int32) is native(LIB) is symbol('xmlValidateAttributeDecl') {*};
    method ValidateDocument(xmlDoc $doc --> int32) is native(LIB) is symbol('xmlValidateDocument') {*};
    method ValidateDocumentFinal(xmlDoc $doc --> int32) is native(LIB) is symbol('xmlValidateDocumentFinal') {*};
    method ValidateDtd(xmlDoc $doc, xmlDtd $dtd --> int32) is native(LIB) is symbol('xmlValidateDtd') {*};
    method ValidateDtdFinal(xmlDoc $doc --> int32) is native(LIB) is symbol('xmlValidateDtdFinal') {*};
    method ValidateElement(xmlDoc $doc, xmlNode $elem --> int32) is native(LIB) is symbol('xmlValidateElement') {*};
    method ValidateElementDecl(xmlDoc $doc, xmlElement $elem --> int32) is native(LIB) is symbol('xmlValidateElementDecl') {*};
    method ValidateNotationDecl(xmlDoc $doc, xmlNotation $nota --> int32) is native(LIB) is symbol('xmlValidateNotationDecl') {*};
    method ValidateNotationUse(xmlDoc $doc, xmlCharP $notationName --> int32) is native(LIB) is symbol('xmlValidateNotationUse') {*};
    method ValidateOneAttribute(xmlDoc $doc, xmlNode $elem, xmlAttr $attr, xmlCharP $value --> int32) is native(LIB) is symbol('xmlValidateOneAttribute') {*};
    method ValidateOneElement(xmlDoc $doc, xmlNode $elem --> int32) is native(LIB) is symbol('xmlValidateOneElement') {*};
    method ValidateOneNamespace(xmlDoc $doc, xmlNode $elem, xmlCharP $prefix, xmlNs $ns, xmlCharP $value --> int32) is native(LIB) is symbol('xmlValidateOneNamespace') {*};
    method ValidatePopElement(xmlDoc $doc, xmlNode $elem, xmlCharP $qname --> int32) is native(LIB) is symbol('xmlValidatePopElement') {*};
    method ValidatePushCData(xmlCharP $data, int32 $len --> int32) is native(LIB) is symbol('xmlValidatePushCData') {*};
    method ValidatePushElement(xmlDoc $doc, xmlNode $elem, xmlCharP $qname --> int32) is native(LIB) is symbol('xmlValidatePushElement') {*};
    method ValidateRoot(xmlDoc $doc --> int32) is native(LIB) is symbol('xmlValidateRoot') {*};
}

class xmlValidState is repr('CPointer') {
}

sub xmlSnprintfElementContent(Str $buf, int32 $size, xmlElementContent $content, int32 $englob) is native(LIB) is export {*};
sub xmlSprintfElementContent(Str $buf, xmlElementContent $content, int32 $englob) is native(LIB) is export {*};
sub xmlValidGetPotentialChildren(xmlElementContent * $ctree, const xmlChar ** $names, Pointer[int32] $len, int32 $max --> int32) is native(LIB) is export {*};
sub xmlValidGetValidElements(xmlNode * $prev, xmlNode * $next, const xmlChar ** $names, int32 $max --> int32) is native(LIB) is export {*};
sub xmlValidateAttributeValue(xmlAttributeType $type, xmlCharP $value --> int32) is native(LIB) is export {*};
sub xmlValidateNameValue(xmlCharP $value --> int32) is native(LIB) is export {*};
sub xmlValidateNamesValue(xmlCharP $value --> int32) is native(LIB) is export {*};
sub xmlValidateNmtokenValue(xmlCharP $value --> int32) is native(LIB) is export {*};
sub xmlValidateNmtokensValue(xmlCharP $value --> int32) is native(LIB) is export {*};
